package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.*;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import javax.management.ObjectName;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface TmstruckTotalResultMapper extends IBaseMapper<TmstruckTotalResult, BigDecimal> {
    //查询最大ID值
    @Select("select seq_tmstruck_total_result.nextval from dual")
    BigDecimal selectMaxId();

    //查询计数作业
    List<Map<String,Object>> selectCountList(Map<String,Object> map);
    //查询包月作业
    List<Map<String, Object>> getTmstruckMonthResult(Map<String, Object> mapValue);

    //查询倒库
    List<Map<String,Object>>  getAllReverseResult(Map<String,Object> map);

    //查询当前没有总实绩的运输订单，为其补录
    List<BigDecimal> getOrderForBulu();

    //查询总实绩Id,线路Id
    Map<String,Object> getLineId(Map<String,Object> map);

    //通过订单Id 查询关联的线路子表顺序
    List<Map<String, Object>> getLineMesByOrderId(Map<String,Object> map);

    //更新订单线路或者路段顺序号
    int updateLineId(Map<String,Object> map);

    //查询所有/有效进厂
    List<TmstruckEnfactoryResult> selectAllEnfactory(Map<String, Object> map);

    //查询所有/有效计量
    List<TmstruckWeightResult> selectAllWeight(Map<String, Object> map);

    //查询所有/有效装货
    List<TmstruckLoadResult> selectAllLoad(Map<String, Object> map);

    //查询所有/有效卸货
    List<TmstruckUnloadResult> selectAllUnload(Map<String, Object> map);

    //查询所有/有效出厂
    List<TmstruckLeaveFactoryResult> selectAllLeavefactory(Map<String, Object> map);

    //删除所有进厂实绩
    int deleteEnByEnTotal(Map<String, Object> map);

    //删除所有计量实绩
    int deleteWeightByEnTotal(Map<String, Object> map);

    //删除所有卸货实绩
    int deleteUnloadByEnTotal(Map<String, Object> map);

    //删除所有出厂实绩
    int deleteLeaveByEnTotal(Map<String, Object> map);
}