package com.steerinfo.dil.service;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * 查询汽运统计报表
 * @ author    :TXF
 * @ time      :2021/12/14 15:25
 */

public interface IStatisticalReportService {

    //查询辅料燃料统计报表
    List<Map<String, Object>> getRLFLReport(Map<String, Object> map);

    //查询采购统计报表 (辅料、燃料、内转)
    List<Map<String, Object>> getAllPurchaseFLRLReport(Map<String, Object> map);

    //查询销售统计报表
    List<Map<String, Object>> getAllSaleReport(Map<String, Object> map);

    //查询销售拼装报表
    List<Map<String, Object>> getSaleSteelSpellingReport(Map<String, Object> map);

    //查询销售统计报表
    List<Map<String, Object>> getAllSaleReportNum(Map<String, Object> map);

//    查询零星物资统计报表
    List<Map<String, Object>> getSporadicSuppliesReportNum1(Map<String, Object> mapValue);
//    查询零星物资统计报表
    List<Map<String, Object>> getSporadicSuppliesReport1(Map<String, Object> mapValue);

    //    查询零星物资统计报表
    List<Map<String, Object>> getSporadicSuppliesReportNum2(Map<String, Object> mapValue);
    //    查询零星物资统计报表
    List<Map<String, Object>> getSporadicSuppliesReport2(Map<String, Object> mapValue);

    List<Map<String, Object>> getPurInwardReport(Map<String, Object> mapValue);

    List<Map<String, Object>> getLXInwardReport( Map<String, Object> mapValue);

    //查看内转统计报表
    List<Map<String, Object>> getInwardReport(Map<String, Object> mapValue);

    List<Map<String, Object>> getLoading(Map<String, Object> mapValue);

    List<Map<String, Object>> getUnLoading(Map<String, Object> mapValue);

    List<Map<String, Object>> getLoaderResult(Map<String, Object> mapValue);

    List<Map<String, Object>> getCapacityByDefend(Map<String, Object> map);

    //查看内转拼装车统计报表
    List<Map<String, Object>> getInwardReportForAssemble(Map<String, Object> mapValue);

    List<Map<String, Object>> getLoaderForResultDetail(Map<String, Object> mapValue);

    //查询该组织机构下的销售统计报表
    List<Map<String, Object>> getSaleOrderList(Map<String, Object> mapValue);

    //查询该组织机构下的采购统计报表
    List<Map<String, Object>> getPurchaseOrderList(Map<String, Object> mapValue);


    //查询该组织机构下的内转统计报表
    List<Map<String, Object>> getPurchaseInwardList(Map<String, Object> mapValue);


    //查看该组织机构下的纯内转统计报表
    List<Map<String,Object>> getInwardInFactory(Map<String,Object> map);

    List<Map<String, Object>> getOutFactoryInwardList(Map<String, Object> mapValue);

    List<Map<String, Object>> getSaleSteelReport(Map<String, Object> mapValue);

    List<Map<String, Object>> getSaleSteelReportNew(Map<String, Object> mapValue);

    List<Map<String, Object>> getSettledSaleSteelReportNew(Map<String, Object> mapValue);

    List<Map<String, Object>> getInwardSaleSteelReport(Map<String, Object> map);

    List<Map<String, Object>> getInwardSaleSteelOrder(Map<String, Object> map);

    Map<String,Object> getSteelReportDetailsBySmId(BigDecimal saleOrderMaterialId);

    //获取收货地址
    String getaddress(BigDecimal addressid);

    //获取收货地址
    BigDecimal getHistoryPrice(BigDecimal addressid);

    //获取车牌号
    String getcapacityNumber(BigDecimal capacitynumber);


    List<Map<String, Object>> loadingSaleSteelReport(Map<String, Object> map);

    //获得是否进出厂的状态
    String getStatus(BigDecimal orderId);

    List<String> getSaleAreaRemark(String saler);

    List<Map<String, Object>> getSaleSteelReportForFinance(Map<String, Object> map);
}

